// C Source File
// Created 12/07/01; 16:46:15
// Realisation: DOUALOT Nicolas

#define OPTIMIZE_ROM_CALLS 					// Use ROM Call Optimization

#define SAVE_SCREEN								// Sauvegarde/Restaure l'ecran
// Declaration des librairies utilises
#include <stdio.h>								// librairie pour les entrees sortie
#include <graph.h>								// librairie pour les graphiques
#include <kbd.h>									// Gestion du clavier

short _ti92plus;									// Produce .9XZ File

//Declaration des variable globales
int ballex,balley,raqx,by,bx,score;

// Deplacement de la balle
void balle(void)
{
	printf_xy(ballex,balley," ");
	ballex+=bx;										//deplacement horizontale
	balley+=by;										//deplacement verticale
	if (ballex<8) bx=8;
	if (ballex>224) bx=-8;
	if (balley<=11)
	{
		by=10;
		score++;
	};
	if ((ballex+bx>=raqx+8)&&(ballex+bx<=raqx+48)&&(balley==101)) by=-10;
	printf_xy(ballex,balley,"O");
}

// Deplacement de la raquette
void raquette(void)
{
	int key=_rowread(0);								//lecture des appuis au clavier
	if ((key & 64) && (raqx<185)) raqx+=8;		//Test pour appuie droite
	if ((key & 16) && (raqx>0)) raqx-=8;		//test pour appuie gauche
	printf_xy(raqx,111," ===== ");				//Trace la raquette
}

// fonction principale
void _main(void)
{
	long int j,dd=0,d=OSInitKeyInitDelay(1/395);	//Diminution du delai de la
															//repetition de touche
	char f=FontSetSys(F_8x10);						//Grande police de caractere
	//initialisation des varaibles globales
	//l'initialisation ce fait ici car sinon une fois la partie perdue,
	//si le jeu n'est pas archiv on ne peut plus y jouer
	//car les variables globale sont mmoriss avec leurs derniere valeur
	//dans le corps du programme.
	ballex=113;
	balley=101;
	raqx=96;
	by=-10;
	bx=8;
	score=0;
	clrscr();
	FontSetSys(F_4x6);
	DrawLine(1,121,239,121,A_NORMAL);
	DrawStr(1,123,"          Realisation :DOUALOT nicolas      DNDD.INC  2001",A_NORMAL);
	for (j=0;j<=900000;j++);						//delai pour la preparation
	// Boucle principale du jeu
	do
	{
		FontSetSys(F_6x8);							//Police normale
		printf_xy(1,1,"Score :""%d",score);
		FontSetSys(F_8x10);							//Grande police de carctere
		raquette();
		if ((200*score)<=10000) dd=100000-1000*score;		//Permettre de voir la balle
		else dd=0;
		for (j=0;j<=dd;j++);
		raquette();
		if ((200*score)<=10000) dd=100000-1000*score;		//Permettre de voir la balle
		else dd=0;
		for (j=0;j<=dd;j++);
		balle();
	}
	while (balley!=111);
	// Fin de la boucle principale
	for (j=0;j<=1800000;j++);						//Permettre de voir la situation a la fin
	ngetchx();
	clrscr();
	printf("Vous avez perdu!!!\nVous avez fait:     points.");	//affichage du score
	printf_xy(129,10,"%d",score);
	FontSetSys(f);
	while (!kbhit());									//Permettre de voir le score
	ngetchx();
	OSInitKeyInitDelay(d);
}
